//#include <windows.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#include <winscard.h>
//#include <scarderr.h>
#include "casmcard.h"
#define NUMBER_OF_READERS	8
#define NAME_LENGTH			100
SCARD_READERSTATE ScardReaderState[2];

int main(int argc, char ** argv)
{
	unsigned char
		szDataOut[262],
		szDataIn[262],
		szAtr[32];
	SCARDCONTEXT
		hContext;
	SCARDHANDLE
		hCard;
	SCARD_READERSTATE 
		ScardReaderState[NUMBER_OF_READERS];

	DWORD
		lRet,
		dwIndex,
		dwReader,
		dwSelect,
		dwShareMode,
		dwProtocol,
		dwPreferedProtocol,
		dwState,
		dwAtrLength = 32,
		dwLengthOut,
		dwLengthIn,
		dwBytesReturned,
		dwIoctl,
		dwAttribut,dwClass,dwTag,
		dwReadersLength;
	LPSTR
		szListReaders;
	LPTSTR
		szFirstReader;

	LPTSTR
		readerName;

	SCARD_IO_REQUEST
		ScardIoRequest;
	int
		nResponse;

	unsigned char szData[256];

	printf("Smart Card Reader Test Suite V1.0\n");
	printf("Copyright(c) Castles Corporation 2008\n");

	/*------------------------------------------------------------------------------
	Establish a context with the ICC Resource Manager.
	------------------------------------------------------------------------------*/
	lRet = CasEstablishContext(SCARD_SCOPE_USER,NULL,NULL,&hContext);
	if (lRet != SCARD_S_SUCCESS)
	{
		printf("SCardEstablishContext fail! ErrorCode = %08X\n",(unsigned int)lRet);
		printf("Press <ENTER> key to terminate!\n");
		nResponse = getchar();
		return 0;
	}
	/*------------------------------------------------------------------------------
	Allocate the size to read the list of the readers
	Get the list of readers.
	------------------------------------------------------------------------------*/
	lRet = CasListReaders(hContext,
							NULL,
							NULL,
							&dwReadersLength);

	if (lRet != SCARD_S_SUCCESS)
	{
		if(lRet == SCARD_E_READER_UNAVAILABLE)
			printf("SCardListReaders: SCARD_E_NO_READERS_AVAILABLE\n");
		else
			printf("SCardListReaders fail! ErrorCode = %08X\n",(unsigned int)lRet);
		printf("Press <ENTER> key to terminate!\n");
		nResponse = getchar();
		lRet = CasReleaseContext(hContext);
		return 0;
	}
	szListReaders = (char*)malloc(dwReadersLength);

	lRet = CasListReaders(hContext,
							NULL,
							(LPTSTR)szListReaders,
							&dwReadersLength);
	readerName=szListReaders;
	if (lRet != SCARD_S_SUCCESS)
	{
		printf("SCardListReader fail! ErrorCode = %08X\n",(unsigned int)lRet);
		printf("Press <ENTER> key to terminate!\n");
		nResponse = getchar();
		lRet = CasReleaseContext(hContext);
		return 0;
	}

	ScardReaderState[0].szReader=readerName;
	readerName+=strlen(readerName)+1;
	ScardReaderState[1].szReader=readerName;

	/*------------------------------------------------------------------------------
	Select a reader
	------------------------------------------------------------------------------*/

	memset((LPVOID)ScardReaderState,0,sizeof(ScardReaderState));
	//ZeroMemory((LPVOID)ScardReaderState, sizeof(ScardReaderState));

	dwIndex = 0;
	dwReader = 0;
	szFirstReader = (LPTSTR)szListReaders;

	while (*(szFirstReader) != '\0')
	{
		if(strcmp("CASTLES EZ710PU 00 01",szFirstReader) == 0)
		{
			dwShareMode = SCARD_SHARE_EXCLUSIVE;
			dwPreferedProtocol = SCARD_PROTOCOL_T0;
			lRet = CasConnect(hContext, 
								(char*)szFirstReader, 
								dwShareMode, 
								SCARD_PROTOCOL_T0, 
								&hCard, 
								&dwProtocol);
			if (lRet != SCARD_S_SUCCESS)
			{
				printf("SCardConnect fail! ErrorCode = %08X\n",(unsigned int)lRet);
				printf("Press <ENTER> key to terminate!\n");
				nResponse = getchar();
				lRet = CasReleaseContext(hContext);
				return 0;
			}
			else
			{
				printf("Please select type of card to test :\n");
				printf("1. Mifare\n");
				printf("2. iCLASS\n");
				printf(">> ");
				
				nResponse = getchar();
				
				if(nResponse == '1')
				{
					const UCHAR key[6] = {0xFF,0xFF,0xFF,0xFF,0xFF,0xFF};
					const UCHAR initvalueblock[16] = {0x64,0x00,0x00,0x00,
													  0x9b,0xff,0xff,0xff,
									   				  0x64,0x00,0x00,0x00,
													  0x05,0xfa,0x05,0xfa};
					UCHAR Mifare_SN[10];
					DWORD Mifare_Len;
					UCHAR block[16];
					ULONG i;
					printf("SCardConnect success\n");

					lRet = CasCLGetSN(hCard,Mifare_SN,10,&Mifare_Len);
	
					printf("get sn = 0x%X\n",(unsigned int)lRet);
					for(i = 0 ; i < Mifare_Len ; i++)
						printf("%x ",Mifare_SN[i]);
					printf("\n");

					lRet = CasMifareAuth(hCard,0x60,0x04,(BYTE*)key,(BYTE*)Mifare_SN);
					printf("auth = 0x%X\n",(unsigned int)lRet);

					lRet = CasMifareReadBlock(hCard,0x05,block);
					printf("read block = 0x%X\n",(unsigned int)lRet);
					for(i = 0 ; i < 16 ; i++)
						printf("%x ",block[i]);
					printf("\n");



					lRet = CasMifareWriteBlock(hCard,0x05,(BYTE*)initvalueblock);
					printf("write block = 0x%X\n",(unsigned int)lRet);
					lRet = CasMifareReadBlock(hCard,0x05,block);
					printf("read block = 0x%X\n",(unsigned int)lRet);
					for(i = 0 ; i < 16 ; i++)
						printf("%x ",block[i]);
					printf("\n");
					
					
					lRet = CasMifareIncrement(hCard,0x05,100);
					printf("increment = 0x%X\n",(unsigned int)lRet);
					
					lRet = CasMifareTransfer(hCard,0x05);
					printf("transfer = 0x%X\n",(unsigned int)lRet);

					lRet = CasMifareDecrement(hCard,0x05,50);
					printf("increment = 0x%X\n",(unsigned int)lRet);
									
					lRet = CasMifareTransfer(hCard,0x05);
					printf("transfer = 0x%X\n",(unsigned int)lRet);

					lRet = CasMifareReadBlock(hCard,0x05,block);
					printf("read block = 0x%X\n",(unsigned int)lRet);
					for(i = 0 ; i < 16 ; i++)
						printf("%x ",block[i]);
					printf("\n");
				}
				else if(nResponse == '2')
				{
					UCHAR UID[8];
					DWORD UID_LEN;
					UCHAR RxBuf[300];
					DWORD RxLen;
					ULONG i;
					const UCHAR readiclass[4] = {0x0C,0x03,0xe8,0x01};
					
					printf("SCardConnect success\n");
					lRet = CasCLGetSN(hCard,UID,8,&UID_LEN);
					printf("get sn = 0x%X\n",(unsigned int)lRet);
					if(lRet == SCARD_S_SUCCESS)
					{
						for(i = 0 ; i < UID_LEN ; i++)
							printf("%x ",UID[i]);
						printf("\n");

					}
					
					lRet = CasiCLASSTransparent(hCard,readiclass,4,RxBuf,300,&RxLen);
					printf("read = 0x%X\n",(unsigned int)lRet);
					if(lRet == SCARD_S_SUCCESS)
					{
						for(i = 0 ; i < RxLen ; i++)
							printf("%x ",RxBuf[i]);
						printf("\n");
					}
				
				}
				
				lRet = CasDisconnect(hCard,SCARD_UNPOWER_CARD);
			}
			
		
		}
		dwIndex += strlen(szFirstReader) + 1;
		szFirstReader = (LPTSTR)(szListReaders + dwIndex);
	}

	return 0;

}
